/*
 *
 * This file is part of the LXARDOSCOPE package.
 *
 * LXARDOSCOPE is an Arduino based oscilloscope for Linux, using the Xforms library.
 *
 * Copyright (C) 2011 Oskar Leuthold
 * 
 * LXARDOSCOPE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * LXARDOSCOPE is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with LXARDOSCOPE; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 */

#include "forms.h"
#include "lxforms.h"
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <time.h>
#include "lxa.h"

#ifndef _REENTRANT
#error ACK! You need to compile with _REENTRANT defined since this uses threads
#endif

FD_lxa *lxa=NULL;
FD_about *about=NULL;

int init_lxa(char *device_name);
int at_close_routine(FL_FORM *frm, void *data);

int main(int argc, char *argv[])
{
    FD_lxa *fd_lxa;
    FD_about *fd_about;
    fl_init();
    fd_lxa = create_form_lxa();
    fd_about = create_form_about();

    about=fd_about;
    lxa=fd_lxa;

    char dev_name[20];
    char *in;
    const char *undef="undefined";  
    const char *dsp = "/dev/";
    strcpy(dev_name,undef);
    if (argc > 1) {
       in=argv[1];
       if(strlen(in)>6 && strlen(in)<14 && strncmp(in,dsp,5)==0) {
            strcpy(dev_name,in);
       }
       else {
       printf("device name %s is not valid\n",in); 
       printf("expect string beginning with /dev/\n");
       printf("select device on lxa Graphical User Interface\n\n");
       }
    }
   init_lxa(dev_name);
// show the GUI; title is defined here
   fl_show_form(fd_lxa->lxa,FL_PLACE_CENTERFREE,FL_FULLBORDER,"lxardoscope_0.8");
   fl_set_atclose(CB_at_close,NULL);
   fl_do_forms();
   return 0;
}
