/*
 *
 * This file is part of the LXARDOSCOPE package.
 *
 * LXARDOSCOPE is an Arduino based oscilloscope for Linux, using the Xforms library.
 *
 * Copyright (C) 2011 Oskar Leuthold
 * 
 * LXARDOSCOPE is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * LXARDOSCOPE is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with LXARDOSCOPE; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <stdlib.h>
#include "forms.h"
#include "lxa.h"		
#include <sys/time.h>           

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <string.h>
#include <termios.h>
  
#define FALSE 0


//*****************************************************************

extern base_info BASE;
extern channel_info CHAN;
extern signed short *rbuf;
extern struct termios oldtio,newtio;

int open_dev()
{
int BAUD;
printf("trying to open device <%s>\n",BASE.device_name);
        BASE.dev_h = open(BASE.device_name, O_RDWR | O_NOCTTY ); 
        if (BASE.dev_h<0) {perror(BASE.device_name); exit(-1); }
printf("success: device open\n");      
        tcgetattr(BASE.dev_h,&oldtio); /* save current port settings */
        
        bzero(&newtio, sizeof(newtio));

     switch (BASE.baud_rate)
      {
         case 115200:
            BAUD = B115200;
            break;
         case 38400:
         default:
            BAUD = B38400;
            break;
         case 19200:
            BAUD  = B19200;
            break;
         case 9600:
            BAUD  = B9600;
            break;
         case 4800:
            BAUD  = B4800;
            break;
         case 2400:
            BAUD  = B2400;
            break;
         case 1800:
            BAUD  = B1800;
            break;
         case 1200:
            BAUD  = B1200;
            break;
         case 600:
            BAUD  = B600;
            break;
         case 300:
            BAUD  = B300;
            break;
		}

        newtio.c_cflag = BAUD | CRTSCTS | CS8 | CLOCAL | CREAD;
        newtio.c_iflag = IGNPAR;
        newtio.c_oflag = 0;
        
        /* set input mode (non-canonical, no echo,...) */
        newtio.c_lflag = 0;
         
        newtio.c_cc[VTIME]    = 0;   /* inter-character timer unused */
        newtio.c_cc[VMIN]     = 200;   /* blocking read until 200 chars received */
        
        tcflush(BASE.dev_h, TCIFLUSH);
        tcsetattr(BASE.dev_h,TCSANOW,&newtio);

  return 1;
}


float get_sample(int chan,int i)
{
  int pos=i*2+chan;
return ((float)rbuf[pos])*BASE.reference/1024.0;
}

